Index: trunk/NEMO/OPA_SRC/TRA/trabbl_adv.h90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/trabbl_adv.h90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/trabbl_adv.h90	(revision 503)
@@ -2,9 +2,12 @@
    !!                     ***  trabbl_adv.h90  ***
    !!----------------------------------------------------------------------
+   !! History :  8.5  !  02-12  (A. de Miranda, G. Madec)  Original Code 
+   !!            9.0  !  04-01  (A. de Miranda, G. Madec, J.M. Molines )
+   !!----------------------------------------------------------------------     
 
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -43,44 +46,29 @@
       !! ** Action  : - update (ta,sa) at the bottom level with the bottom
       !!                boundary layer trend
-      !!              - save the lateral diffusion trends in tldfbbl/sldfbbl ('key_trdtra')
-      !!              - save the horizontal advection trends in tladbbl/sladbbl ('key_trdtra')
       !!
-      !! References :
-      !!     Beckmann, A., and R. Doscher, 1997, J. Phys.Oceanogr., 581-591.
+      !! References : Beckmann, A., and R. Doscher, 1997, J. Phys.Oceanogr., 581-591.
+      !!----------------------------------------------------------------------     
+      USE eosbn2                      ! equation of state
+      USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
+      USE oce, ONLY :   ztrds => va   ! use va as 3D workspace   
       !!
-      !! History :
-      !!   8.5  !  02-12  (A. de Miranda, G. Madec)  Original Code 
-      !!   9.0  !  04-01  (A. de Miranda, G. Madec, J.M. Molines )
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------     
-      !! * Modules used
-      USE eosbn2                           ! equation of state
-      USE oce, ONLY :    ztdta => ua,    & ! use ua as 3D workspace   
-                         ztdsa => va       ! use va as 3D workspace   
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt        ! ocean time-step 
-      
-      !! * Local declarations
-      INTEGER :: ji, jj, jk                ! dummy loop indices
-      INTEGER :: ik, iku, ikv              ! temporary integers
-
-      REAL(wp) ::   &
-         zsign, zt, zs, zh, zalbet,     &  ! temporary scalars
-         zgdrho, zbtr, zta, zsa            !    "         " 
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         ztnb, zsnb, zdep, ztbb, zsbb
-      REAL(wp), DIMENSION(jpi,jpj) ::   &  ! temporary workspace arrays
-         zalphax, zwu, zunb,            &  !    "                  "
-         zalphay, zwv, zvnb,            &  !    "                  "
-         zwx, zwy, zww, zwz                !    "                  "
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         zhdivn                            ! temporary workspace arrays
-      REAL(wp) ::   &
-         zfui, zfvj, zbt, zsigna,       &  ! temporary scalars
-         iku1, iku2, ikv1, ikv2,        &  ! temporary scalars
-         ze3u,ze3v
-      REAL(wp) ::   &
-         fsalbt, pft, pfs, pfh             ! statement function
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step 
+      !!
+      INTEGER  ::   ji, jj, jk        ! dummy loop indices
+      INTEGER  ::   ik                ! temporary integers
+      INTEGER  ::   iku, iku1, iku2   !    "          "
+      INTEGER  ::   ikv, ikv1, ikv2   !    "          "
+      REAL(wp) ::   zsign, zh, zalbet     ! temporary scalars
+      REAL(wp) ::   zgdrho, zbtr          !    "         " 
+      REAL(wp) ::   zbt, zsigna           !    "         "
+      REAL(wp) ::   zfui, ze3u, zt, zta   !    "         "
+      REAL(wp) ::   zfvj, ze3v, zs, zsa   !    "         "
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zalphax, zwu, zunb   ! temporary 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zalphay, zwv, zvnb   !    "             "
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zwx, zwy, zww, zwz   !    "             "
+      REAL(wp), DIMENSION(jpi,jpj)     ::   ztbb, zsbb           !    "             "
+      REAL(wp), DIMENSION(jpi,jpj)     ::   ztnb, zsnb, zdep     !    "             "
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zhdivn               ! temporary 3D workspace
+      REAL(wp) ::   fsalbt, pft, pfs, pfh   ! statement function
       !!----------------------------------------------------------------------
       ! ratio alpha/beta
@@ -108,8 +96,7 @@
       IF( kt == nit000 )   CALL tra_bbl_init    ! initialization at first time-step
 
-      ! Save ta and sa trends
-      IF( l_trdtra )   THEN
-         ztdta(:,:,:) = ta(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) 
+      IF( l_trdtra )   THEN      ! Save ta and sa trends
+         ztrdt(:,:,:) = ta(:,:,:) 
+         ztrds(:,:,:) = sa(:,:,:) 
       ENDIF
 
@@ -146,48 +133,47 @@
 
       SELECT CASE ( neos )
-
+      !
       CASE ( 0 )               ! Jackett and McDougall (1994) formulation
-
+      !
       DO jj = 1, jpjm1
-        DO ji = 1, fs_jpim1   ! vector opt.
-      !   ... temperature, salinity anomalie and depth
-          zt = 0.5 * ( ztnb(ji,jj) + ztnb(ji+1,jj) )
-          zs = 0.5 * ( zsnb(ji,jj) + zsnb(ji+1,jj) ) - 35.0
-          zh = 0.5 * ( zdep(ji,jj) + zdep(ji+1,jj) )
-      !   ... masked ratio alpha/beta
-          zalbet = fsalbt( zt, zs, zh ) * umask(ji,jj,1)
-      !   ... local density gradient along i-bathymetric slope
-          zgdrho = zalbet * ( ztnb(ji+1,jj) - ztnb(ji,jj) )   &
-             &       -      ( zsnb(ji+1,jj) - zsnb(ji,jj) )
-          zgdrho = zgdrho * umask(ji,jj,1)
-      !   ... sign of local i-gradient of density multiplied by the i-slope
-          zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-          zsigna= SIGN( 0.5, zunb(ji,jj) * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-          zalphax(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * umask(ji,jj,1)
-        END DO
-      END DO
-
+         DO ji = 1, fs_jpim1   ! vector opt.
+            !   ... temperature, salinity anomalie and depth
+            zt = 0.5 * ( ztnb(ji,jj) + ztnb(ji+1,jj) )
+            zs = 0.5 * ( zsnb(ji,jj) + zsnb(ji+1,jj) ) - 35.0
+            zh = 0.5 * ( zdep(ji,jj) + zdep(ji+1,jj) )
+            !   ... masked ratio alpha/beta
+            zalbet = fsalbt( zt, zs, zh ) * umask(ji,jj,1)
+            !   ... local density gradient along i-bathymetric slope
+            zgdrho = zalbet * ( ztnb(ji+1,jj) - ztnb(ji,jj) )   &
+               &       -      ( zsnb(ji+1,jj) - zsnb(ji,jj) )
+            zgdrho = zgdrho * umask(ji,jj,1)
+            !   ... sign of local i-gradient of density multiplied by the i-slope
+            zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+            zsigna= SIGN( 0.5, zunb(ji,jj) * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+            zalphax(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * umask(ji,jj,1)
+         END DO
+      END DO
+      !
       DO jj = 1, jpjm1
-        DO ji = 1, fs_jpim1   ! vector opt.
-      !   ... temperature, salinity anomalie and depth
-          zt = 0.5 * ( ztnb(ji,jj+1) + ztnb(ji,jj) )
-          zs = 0.5 * ( zsnb(ji,jj+1) + zsnb(ji,jj) ) - 35.0
-          zh = 0.5 * ( zdep(ji,jj+1) + zdep(ji,jj) )
-      !   ... masked ratio alpha/beta
-          zalbet = fsalbt( zt, zs, zh ) * vmask(ji,jj,1)
-      !   ... local density gradient along j-bathymetric slope
-          zgdrho = zalbet * ( ztnb(ji,jj+1) - ztnb(ji,jj) )   &
-             &       -      ( zsnb(ji,jj+1) - zsnb(ji,jj) )
-          zgdrho = zgdrho*vmask(ji,jj,1)
-      !   ... sign of local j-gradient of density multiplied by the j-slope
-          zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-          zsigna= SIGN( 0.5, zvnb(ji,jj) * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-          zalphay(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * vmask(ji,jj,1)
-        END DO
-      END DO
-
-
+         DO ji = 1, fs_jpim1   ! vector opt.
+            !   ... temperature, salinity anomalie and depth
+            zt = 0.5 * ( ztnb(ji,jj+1) + ztnb(ji,jj) )
+            zs = 0.5 * ( zsnb(ji,jj+1) + zsnb(ji,jj) ) - 35.0
+            zh = 0.5 * ( zdep(ji,jj+1) + zdep(ji,jj) )
+            !   ... masked ratio alpha/beta
+            zalbet = fsalbt( zt, zs, zh ) * vmask(ji,jj,1)
+            !   ... local density gradient along j-bathymetric slope
+            zgdrho = zalbet * ( ztnb(ji,jj+1) - ztnb(ji,jj) )   &
+               &       -      ( zsnb(ji,jj+1) - zsnb(ji,jj) )
+            zgdrho = zgdrho*vmask(ji,jj,1)
+            !   ... sign of local j-gradient of density multiplied by the j-slope
+            zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+            zsigna= SIGN( 0.5, zvnb(ji,jj) * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+            zalphay(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * vmask(ji,jj,1)
+         END DO
+      END DO
+      !
       CASE ( 1 )               ! Linear formulation function of temperature only
-                               !
+      !
       DO jj = 1, jpjm1
          DO ji = 1, fs_jpim1   ! vector opt.
@@ -207,6 +193,7 @@
          END DO
       END DO
-
+      !
       CASE ( 2 )               ! Linear formulation function of temperature and salinity
+      !
       DO jj = 1, jpjm1
          DO ji = 1, fs_jpim1   ! vector opt.            
@@ -228,10 +215,9 @@
          END DO
       END DO
-
+      !
       CASE DEFAULT
-
          WRITE(ctmp1,*) '          bad flag value for neos = ', neos
          CALL ctl_stop( ctmp1 )
-
+         !
       END SELECT
 
@@ -359,26 +345,11 @@
       ! BBL lateral advection tracers trends
       IF( l_trdtra )   THEN
-#  if defined key_vectopt_loop   &&   ! defined key_mpp_omp
-         jj = 1
-         DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
-#  else
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
-#  endif
-            ik = mbkt(ji,jj)
-            tladbbl(ji,jj) = ta(ji,jj,ik) - ztdta(ji,jj,ik)
-            sladbbl(ji,jj) = sa(ji,jj,ik) - ztdsa(ji,jj,ik)
-#  if ! defined key_vectopt_loop   ||   defined key_mpp_omp
-            END DO
-#  endif
-         END DO
-
+         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
+         ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_bbl, 'TRA', kt)
       ENDIF
 
-      IF(ln_ctl) THEN
-         CALL prt_ctl(tab3d_1=ta, clinfo1=' bbl  - Ta: ', mask1=tmask, &
-            &         tab3d_2=sa, clinfo2=' Sa: ', mask2=tmask, clinfo3='tra')
-      ENDIF
-
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' bbl  - Ta: ', mask1=tmask,   &
+         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
 
       ! 6. Vertical advection velocities
@@ -475,5 +446,4 @@
       ! 7. compute additional vertical velocity to be used in t boxes
       ! -------------------------------------------------------------
-
       ! ... Computation from the bottom
       ! Note that w_bbl(:,:,jpk) has been set to 0 in tra_bbl_init
@@ -488,4 +458,4 @@
       ! Boundary condition on w_bbl   (unchanged sign)
       CALL lbc_lnk( w_bbl, 'W', 1. )
-
+      !
    END SUBROUTINE tra_bbl_adv
